//
// AuditlogsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class AuditlogsAPI {
    /**
     Get list of audit log entries, filtered by period, user ID and action type

     - parameter userIds: (query)  (optional)
     - parameter actionTypes: (query)  (optional)
     - parameter createdAtFrom: (query)  (optional)
     - parameter createdAtTo: (query)  (optional)
     - parameter orderBy: (query)  (optional)
     - parameter organizationId: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getAuditLogEntries(userIds: [Int]? = nil, actionTypes: [ActionType]? = nil, createdAtFrom: Date? = nil, createdAtTo: Date? = nil, orderBy: AuditLogGetOrder? = nil, organizationId: Int? = nil, completion: @escaping ((_ data: AuditLogList?,_ error: Error?) -> Void)) {
        getAuditLogEntriesWithRequestBuilder(userIds: userIds, actionTypes: actionTypes, createdAtFrom: createdAtFrom, createdAtTo: createdAtTo, orderBy: orderBy, organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of audit log entries, filtered by period, user ID and action type
     - GET /api/v1/auditlogs

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "auditlogs" : [ {
    "user_email" : "user_email",
    "action_type" : "camera_create",
    "user_last_name" : "user_last_name",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "user_is_superuser" : true,
    "organization_name" : "organization_name",
    "user_role_name" : "user_role_name",
    "user_avatar_url" : "http://example.com/aeiou",
    "user_role_id" : 1,
    "user_first_name" : "user_first_name",
    "user_id" : 0,
    "meta" : { },
    "user_avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "organization_id" : 6,
    "client_ip" : "client_ip",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "user_groups" : [ {
      "name" : "name",
      "id" : 5
    }, {
      "name" : "name",
      "id" : 5
    } ]
  }, {
    "user_email" : "user_email",
    "action_type" : "camera_create",
    "user_last_name" : "user_last_name",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "user_is_superuser" : true,
    "organization_name" : "organization_name",
    "user_role_name" : "user_role_name",
    "user_avatar_url" : "http://example.com/aeiou",
    "user_role_id" : 1,
    "user_first_name" : "user_first_name",
    "user_id" : 0,
    "meta" : { },
    "user_avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "organization_id" : 6,
    "client_ip" : "client_ip",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "user_groups" : [ {
      "name" : "name",
      "id" : 5
    }, {
      "name" : "name",
      "id" : 5
    } ]
  } ]
}}]
     - parameter userIds: (query)  (optional)
     - parameter actionTypes: (query)  (optional)
     - parameter createdAtFrom: (query)  (optional)
     - parameter createdAtTo: (query)  (optional)
     - parameter orderBy: (query)  (optional)
     - parameter organizationId: (query)  (optional)

     - returns: RequestBuilder<AuditLogList> 
     */
    open class func getAuditLogEntriesWithRequestBuilder(userIds: [Int]? = nil, actionTypes: [ActionType]? = nil, createdAtFrom: Date? = nil, createdAtTo: Date? = nil, orderBy: AuditLogGetOrder? = nil, organizationId: Int? = nil) -> RequestBuilder<AuditLogList> {
        let path = "/api/v1/auditlogs"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "user_ids": userIds, 
                        "action_types": actionTypes, 
                        "created_at_from": createdAtFrom?.encodeToJSON(), 
                        "created_at_to": createdAtTo?.encodeToJSON(), 
                        "order_by": orderBy, 
                        "organization_id": organizationId?.encodeToJSON()
        ])


        let requestBuilder: RequestBuilder<AuditLogList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get audit log entry by provided ID

     - parameter auditlogId: (path)  
     - parameter organizationId: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getAuditLogEntry(auditlogId: UUID, organizationId: Int? = nil, completion: @escaping ((_ data: AuditLogGet?,_ error: Error?) -> Void)) {
        getAuditLogEntryWithRequestBuilder(auditlogId: auditlogId, organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get audit log entry by provided ID
     - GET /api/v1/auditlogs/{auditlog_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "user_email" : "user_email",
  "action_type" : "camera_create",
  "user_last_name" : "user_last_name",
  "created_at" : "2000-01-23T04:56:07.000+00:00",
  "user_is_superuser" : true,
  "organization_name" : "organization_name",
  "user_role_name" : "user_role_name",
  "user_avatar_url" : "http://example.com/aeiou",
  "user_role_id" : 1,
  "user_first_name" : "user_first_name",
  "user_id" : 0,
  "meta" : { },
  "user_avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "organization_id" : 6,
  "client_ip" : "client_ip",
  "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "user_groups" : [ {
    "name" : "name",
    "id" : 5
  }, {
    "name" : "name",
    "id" : 5
  } ]
}}]
     - parameter auditlogId: (path)  
     - parameter organizationId: (query)  (optional)

     - returns: RequestBuilder<AuditLogGet> 
     */
    open class func getAuditLogEntryWithRequestBuilder(auditlogId: UUID, organizationId: Int? = nil) -> RequestBuilder<AuditLogGet> {
        var path = "/api/v1/auditlogs/{auditlog_id}"
        let auditlogIdPreEscape = "\(auditlogId)"
        let auditlogIdPostEscape = auditlogIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{auditlog_id}", with: auditlogIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "organization_id": organizationId?.encodeToJSON()
        ])


        let requestBuilder: RequestBuilder<AuditLogGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
